import { ModifierOptions } from './types';
export declare abstract class Attribute<T = Record<string, unknown>> {
    static options: ModifierOptions;
    element?: HTMLElement;
    value?: string;
    selector?: string;
    parent?: HTMLElement;
    observer?: MutationObserver;
    setStyles(keys: T): (div: HTMLElement | Element | HTMLDivElement) => void;
    OnInit(): void;
    OnDestroy(): void;
    OnUpdate(_oldValue: string, _newValue: string): void;
    OnUpdateAttribute(_name: string, _value: string): void;
    OnChange(_records: MutationRecord[]): void;
}
