"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.observe = exports.noop = void 0;
const noop = function () {
    /*  */
};
exports.noop = noop;
const observe = (target, memberName) => {
    const prototype = target.constructor.prototype;
    const OnInit = prototype.OnInit || exports.noop;
    const OnDestroy = prototype.OnDestroy || exports.noop;
    const OnUpdateAttribute = prototype.OnUpdateAttribute || exports.noop;
    let observer;
    prototype.OnInit = function () {
        var _a;
        const element = (_a = this.element) !== null && _a !== void 0 ? _a : this;
        if (observer) {
            observer.disconnect();
        }
        observer = new MutationObserver(() => {
            OnUpdateAttribute.call(this, memberName, element.getAttribute(memberName));
            target[memberName] = element.getAttribute(memberName);
        });
        observer.observe(element, {
            attributeFilter: [memberName],
            attributes: true,
        });
        return OnInit.call(this);
    };
    prototype.OnDestroy = function () {
        observer.disconnect();
        return OnDestroy.call(this);
    };
};
exports.observe = observe;
//# sourceMappingURL=index.js.map