import { Attribute } from './attribute';
/**
 * Media query Attribute
 * for performance reasons it is key value pair
 */
export declare const MediaMatchers: Map<string, string>;
export type MediaEvent = MediaQueryList | MediaQueryListEvent;
export type MediaQueryEvent = [MediaEvent, Attr];
export interface OnUpdateMediaQuery {
    OnEnterMediaQuery(tuple: MediaQueryEvent): void;
    OnExitMediaQuery(tuple: MediaQueryEvent): void;
}
export declare const Breakpoints: string[];
export declare const createFiltersFromSelector: (selector: string) => string[];
export declare abstract class MediaQueryAttribute<T> extends Attribute<T> implements OnUpdateMediaQuery {
    private matchers;
    private cachedAttributes;
    listener: (event: MediaQueryList | MediaQueryListEvent) => void;
    OnInit(): void;
    OnDestroy(): void;
    abstract OnEnterMediaQuery(tuple: MediaQueryEvent): void;
    abstract OnExitMediaQuery(tuple: MediaQueryEvent): void;
}
